/*****************************************************************************
 * xpf_driver.h: Definitions used to implement the Unix-style xpf-driver.    *
 *		For an x-Kernel driver, one just has to implement an	     *
 *		xpf_demux() using xpf_read -- rest is identical in both.     *
 *		Delivery and Xmission of messages are done outside xpf.	     *
 *****************************************************************************/

#ifndef	_XPF_DRIVER_H_
#define _XPF_DRIVER_H_
#include "xpf_interface.h"

/* Control-operations that are supported by the xpf-driver */

#define XPF_RANDOM	0x6f2a5b90	/* avoid clash with other opcodes */
#define XPF_SETUP	(XPF_RANDOM + 1)
#define XPF_REMOVE	(XPF_RANDOM + 2)
#define XPF_SETUPSUFFIX	(XPF_RANDOM + 3)

/* Each operation expects a pointer to a different argument type in "buf" */

typedef struct _XPFSetupArg {
	XPFPattern	*pattern;
	XPFInformation	information;
} XPFSetupArg;

typedef XPFSetupArg XPFRemoveArg;

typedef struct _XPFSetupSuffixArg {
	XPFPattern	*prefix, *new, *findsuffix;
	XPFInformation	information;
} XPFSetupSuffixArg;

/* Usage and return values: consistent with those of a standard Unix driver */

#if	PROTOTYPE
XPFObject	xpf_open(void);
int		xpf_ioctl(XPFObject xpfobj, int opcode, char *buf, int len);
XPFInformation	xpf_read(XPFObject xpfobj, XPFMessage msg, int len);
void		xpf_close(XPFObject xpfobj);
#else	PROTOTYPE
XPFObject	xpf_open();
int		xpf_ioctl();
XPFInformation	xpf_read();
void		xpf_close();
#endif	PROTOTYPE
#endif	_XPF_DRIVER_H_
